﻿using System;
using Vintagestory.API.Client;
using Vintagestory.API.Common;
using Vintagestory.API.Common.Entities;
using Vintagestory.API.Config;
using Vintagestory.API.Datastructures;
using Vintagestory.GameContent;
using Vintagestory.API.MathTools;
using Vintagestory.API.Server;
using Vintagestory.API.Util;

namespace opets.de
{
	public class bedSpawn : ModSystem
	{
		private ICoreServerAPI serverApi;

		public override void StartServerSide(ICoreServerAPI api)
		{
			serverApi = api;

			api.Event.DidUseBlock += OnUseBlock;
		}

		public void OnUseBlock(IServerPlayer byPlayer, BlockSelection blockSel)
		{
			if (blockSel?.Position == null)
            {
				return;
			} 
			else if (!(serverApi.World.BlockAccessor.GetBlock(blockSel?.Position) is BlockBed))
			{
				return;
			} 
			else
            {
				byPlayer.SetSpawnPosition(new PlayerSpawnPos()
				{
					x = blockSel.Position.X,
					y = blockSel.Position.Y,
					z = blockSel.Position.Z,
				});

				serverApi.SendMessage(byPlayer, GlobalConstants.GeneralChatGroup, "set new respawn point", EnumChatType.OwnMessage);
			}
		}
	}
}
